const R = require('../rambda')

const array1 = [ 1, 2, 3 ]
const array2 = [ 'A', 'B', 'C' ]

describe('zip', () => {
  it('should return an array', () => {
    const actual = R.zip(array1)(array2)
    expect(actual).toBeInstanceOf(Array)
  })

  it('should return and array or tuples', () => {
    const expected = [ [ 1, 'A' ], [ 2, 'B' ], [ 3, 'C' ] ]
    const actual = R.zip(array1, array2)
    expect(actual).toEqual(expected)
  })

  it('should truncate result to length of shorted input list', () => {
    const expectedA = [ [ 1, 'A' ], [ 2, 'B' ] ]
    const actualA = R.zip([ 1, 2 ], array2)
    expect(actualA).toEqual(expectedA)

    const expectedB = [ [ 1, 'A' ], [ 2, 'B' ] ]
    const actualB = R.zip(array1, [ 'A', 'B' ])
    expect(actualB).toEqual(expectedB)
  })
})
